OpenCV: cv::ocl::Device Class Reference

| OpenCV 3.4.2 Open Source Computer Vision

Public Types | Public Member Functions | Static Public Member Functions | Protected Attributes | List of all members
cv::ocl::Device Class Reference
Core functionality » OpenCL support

`#include "ocl.hpp"`

## Public Types
enum | { TYPE_DEFAULT = (1 << 0), TYPE_CPU = (1 << 1), TYPE_GPU = (1 << 2), TYPE_ACCELERATOR = (1 << 3), TYPE_DGPU = TYPE_GPU + (1 << 16), TYPE_IGPU = TYPE_GPU + (1 << 17), TYPE_ALL = 0xFFFFFFFF }
enum | { FP_DENORM =(1 << 0), FP_INF_NAN =(1 << 1), FP_ROUND_TO_NEAREST =(1 << 2), FP_ROUND_TO_ZERO =(1 << 3), FP_ROUND_TO_INF =(1 << 4), FP_FMA =(1 << 5), FP_SOFT_FLOAT =(1 << 6), FP_CORRECTLY_ROUNDED_DIVIDE_SQRT =(1 << 7) }
enum | { EXEC_KERNEL =(1 << 0), EXEC_NATIVE_KERNEL =(1 << 1) }
enum | { NO_CACHE =0, READ_ONLY_CACHE =1, READ_WRITE_CACHE =2 }
enum | { NO_LOCAL_MEM =0, LOCAL_IS_LOCAL =1, LOCAL_IS_GLOBAL =2 }
enum | { UNKNOWN_VENDOR =0, VENDOR_AMD =1, VENDOR_INTEL =2, VENDOR_NVIDIA =3 }

## Public Member Functions
| Device ()
| Device (void *d)
| Device (const Device &d)
| ~Device ()
int | addressBits () const
bool | available () const
bool | compilerAvailable () const
int | deviceVersionMajor () const
int | deviceVersionMinor () const
int | doubleFPConfig () const
String | driverVersion () const
bool | endianLittle () const
bool | errorCorrectionSupport () const
int | executionCapabilities () const
String | extensions () const
int | globalMemCacheLineSize () const
size_t | globalMemCacheSize () const
int | globalMemCacheType () const
size_t | globalMemSize () const
int | halfFPConfig () const
bool | hostUnifiedMemory () const
size_t | image2DMaxHeight () const
size_t | image2DMaxWidth () const
size_t | image3DMaxDepth () const
size_t | image3DMaxHeight () const
size_t | image3DMaxWidth () const
uint | imageBaseAddressAlignment () const
bool | imageFromBufferSupport () const
size_t | imageMaxArraySize () const
size_t | imageMaxBufferSize () const
uint | imagePitchAlignment () const
bool | imageSupport () const
bool | intelSubgroupsSupport () const
| deprecated, use isExtensionSupported() method (probably with "cl_khr_subgroups" value) More...
bool | isAMD () const
bool | isExtensionSupported (const String &extensionName) const
bool | isIntel () const
bool | isNVidia () const
bool | linkerAvailable () const
size_t | localMemSize () const
int | localMemType () const
int | maxClockFrequency () const
int | maxComputeUnits () const
int | maxConstantArgs () const
size_t | maxConstantBufferSize () const
size_t | maxMemAllocSize () const
size_t | maxParameterSize () const
int | maxReadImageArgs () const
int | maxSamplers () const
size_t | maxWorkGroupSize () const
int | maxWorkItemDims () const
void | maxWorkItemSizes (size_t *) const
int | maxWriteImageArgs () const
int | memBaseAddrAlign () const
String | name () const
int | nativeVectorWidthChar () const
int | nativeVectorWidthDouble () const
int | nativeVectorWidthFloat () const
int | nativeVectorWidthHalf () const
int | nativeVectorWidthInt () const
int | nativeVectorWidthLong () const
int | nativeVectorWidthShort () const
String | OpenCL_C_Version () const
String | OpenCLVersion () const
Device & | operator= (const Device &d)
int | preferredVectorWidthChar () const
int | preferredVectorWidthDouble () const
int | preferredVectorWidthFloat () const
int | preferredVectorWidthHalf () const
int | preferredVectorWidthInt () const
int | preferredVectorWidthLong () const
int | preferredVectorWidthShort () const
size_t | printfBufferSize () const
size_t | profilingTimerResolution () const
void * | ptr () const
void | set (void *d)
int | singleFPConfig () const
int | type () const
int | vendorID () const
String | vendorName () const
String | version () const

## Static Public Member Functions
static const Device & | getDefault ()

## Protected Attributes
Impl * | p

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
TYPE_DEFAULT |
TYPE_CPU |
TYPE_GPU |
TYPE_ACCELERATOR |
TYPE_DGPU |
TYPE_IGPU |
TYPE_ALL |

## ◆ anonymous enum

anonymous enum

Enumerator
FP_DENORM |
FP_INF_NAN |
FP_ROUND_TO_NEAREST |
FP_ROUND_TO_ZERO |
FP_ROUND_TO_INF |
FP_FMA |
FP_SOFT_FLOAT |
FP_CORRECTLY_ROUNDED_DIVIDE_SQRT |

## ◆ anonymous enum

anonymous enum

Enumerator
EXEC_KERNEL |
EXEC_NATIVE_KERNEL |

## ◆ anonymous enum

anonymous enum

Enumerator
NO_CACHE |
READ_ONLY_CACHE |
READ_WRITE_CACHE |

## ◆ anonymous enum

anonymous enum

Enumerator
NO_LOCAL_MEM |
LOCAL_IS_LOCAL |
LOCAL_IS_GLOBAL |

## ◆ anonymous enum

anonymous enum

Enumerator
UNKNOWN_VENDOR |
VENDOR_AMD |
VENDOR_INTEL |
VENDOR_NVIDIA |

## Constructor & Destructor Documentation

## ◆ Device() [1/3]

cv::ocl::Device::Device | ( |  | ) |

## ◆ Device() [2/3]

cv::ocl::Device::Device | ( | void * | d | ) |
| explicit

## ◆ Device() [3/3]

cv::ocl::Device::Device | ( | const Device & | d | ) |

## ◆ ~Device()

cv::ocl::Device::~Device | ( |  | ) |

## Member Function Documentation

## ◆ addressBits()

int cv::ocl::Device::addressBits | ( |  | ) | const

## ◆ available()

bool cv::ocl::Device::available | ( |  | ) | const

## ◆ compilerAvailable()

bool cv::ocl::Device::compilerAvailable | ( |  | ) | const

## ◆ deviceVersionMajor()

int cv::ocl::Device::deviceVersionMajor | ( |  | ) | const

## ◆ deviceVersionMinor()

int cv::ocl::Device::deviceVersionMinor | ( |  | ) | const

## ◆ doubleFPConfig()

int cv::ocl::Device::doubleFPConfig | ( |  | ) | const

## ◆ driverVersion()

String cv::ocl::Device::driverVersion | ( |  | ) | const

## ◆ endianLittle()

bool cv::ocl::Device::endianLittle | ( |  | ) | const

## ◆ errorCorrectionSupport()

bool cv::ocl::Device::errorCorrectionSupport | ( |  | ) | const

## ◆ executionCapabilities()

int cv::ocl::Device::executionCapabilities | ( |  | ) | const

## ◆ extensions()

String cv::ocl::Device::extensions | ( |  | ) | const

## ◆ getDefault()

static const Device& cv::ocl::Device::getDefault | ( |  | ) |
| static

## ◆ globalMemCacheLineSize()

int cv::ocl::Device::globalMemCacheLineSize | ( |  | ) | const

## ◆ globalMemCacheSize()

size_t cv::ocl::Device::globalMemCacheSize | ( |  | ) | const

## ◆ globalMemCacheType()

int cv::ocl::Device::globalMemCacheType | ( |  | ) | const

## ◆ globalMemSize()

size_t cv::ocl::Device::globalMemSize | ( |  | ) | const

## ◆ halfFPConfig()

int cv::ocl::Device::halfFPConfig | ( |  | ) | const

## ◆ hostUnifiedMemory()

bool cv::ocl::Device::hostUnifiedMemory | ( |  | ) | const

## ◆ image2DMaxHeight()

size_t cv::ocl::Device::image2DMaxHeight | ( |  | ) | const

## ◆ image2DMaxWidth()

size_t cv::ocl::Device::image2DMaxWidth | ( |  | ) | const

## ◆ image3DMaxDepth()

size_t cv::ocl::Device::image3DMaxDepth | ( |  | ) | const

## ◆ image3DMaxHeight()

size_t cv::ocl::Device::image3DMaxHeight | ( |  | ) | const

## ◆ image3DMaxWidth()

size_t cv::ocl::Device::image3DMaxWidth | ( |  | ) | const

## ◆ imageBaseAddressAlignment()

uint cv::ocl::Device::imageBaseAddressAlignment | ( |  | ) | const

## ◆ imageFromBufferSupport()

bool cv::ocl::Device::imageFromBufferSupport | ( |  | ) | const

## ◆ imageMaxArraySize()

size_t cv::ocl::Device::imageMaxArraySize | ( |  | ) | const

## ◆ imageMaxBufferSize()

size_t cv::ocl::Device::imageMaxBufferSize | ( |  | ) | const

## ◆ imagePitchAlignment()

uint cv::ocl::Device::imagePitchAlignment | ( |  | ) | const

## ◆ imageSupport()

bool cv::ocl::Device::imageSupport | ( |  | ) | const

## ◆ intelSubgroupsSupport()

bool cv::ocl::Device::intelSubgroupsSupport | ( |  | ) | const

deprecated, use isExtensionSupported() method (probably with "cl_khr_subgroups" value)

## ◆ isAMD()

bool cv::ocl::Device::isAMD | ( |  | ) | const
| inline

## ◆ isExtensionSupported()

bool cv::ocl::Device::isExtensionSupported | ( | const String & | extensionName | ) | const

## ◆ isIntel()

bool cv::ocl::Device::isIntel | ( |  | ) | const
| inline

## ◆ isNVidia()

bool cv::ocl::Device::isNVidia | ( |  | ) | const
| inline

## ◆ linkerAvailable()

bool cv::ocl::Device::linkerAvailable | ( |  | ) | const

## ◆ localMemSize()

size_t cv::ocl::Device::localMemSize | ( |  | ) | const

## ◆ localMemType()

int cv::ocl::Device::localMemType | ( |  | ) | const

## ◆ maxClockFrequency()

int cv::ocl::Device::maxClockFrequency | ( |  | ) | const

## ◆ maxComputeUnits()

int cv::ocl::Device::maxComputeUnits | ( |  | ) | const

## ◆ maxConstantArgs()

int cv::ocl::Device::maxConstantArgs | ( |  | ) | const

## ◆ maxConstantBufferSize()

size_t cv::ocl::Device::maxConstantBufferSize | ( |  | ) | const

## ◆ maxMemAllocSize()

size_t cv::ocl::Device::maxMemAllocSize | ( |  | ) | const

## ◆ maxParameterSize()

size_t cv::ocl::Device::maxParameterSize | ( |  | ) | const

## ◆ maxReadImageArgs()

int cv::ocl::Device::maxReadImageArgs | ( |  | ) | const

## ◆ maxSamplers()

int cv::ocl::Device::maxSamplers | ( |  | ) | const

## ◆ maxWorkGroupSize()

size_t cv::ocl::Device::maxWorkGroupSize | ( |  | ) | const

## ◆ maxWorkItemDims()

int cv::ocl::Device::maxWorkItemDims | ( |  | ) | const

## ◆ maxWorkItemSizes()

void cv::ocl::Device::maxWorkItemSizes | ( | size_t * |  | ) | const

## ◆ maxWriteImageArgs()

int cv::ocl::Device::maxWriteImageArgs | ( |  | ) | const

## ◆ memBaseAddrAlign()

int cv::ocl::Device::memBaseAddrAlign | ( |  | ) | const

## ◆ name()

String cv::ocl::Device::name | ( |  | ) | const

## ◆ nativeVectorWidthChar()

int cv::ocl::Device::nativeVectorWidthChar | ( |  | ) | const

## ◆ nativeVectorWidthDouble()

int cv::ocl::Device::nativeVectorWidthDouble | ( |  | ) | const

## ◆ nativeVectorWidthFloat()

int cv::ocl::Device::nativeVectorWidthFloat | ( |  | ) | const

## ◆ nativeVectorWidthHalf()

int cv::ocl::Device::nativeVectorWidthHalf | ( |  | ) | const

## ◆ nativeVectorWidthInt()

int cv::ocl::Device::nativeVectorWidthInt | ( |  | ) | const

## ◆ nativeVectorWidthLong()

int cv::ocl::Device::nativeVectorWidthLong | ( |  | ) | const

## ◆ nativeVectorWidthShort()

int cv::ocl::Device::nativeVectorWidthShort | ( |  | ) | const

## ◆ OpenCL_C_Version()

String cv::ocl::Device::OpenCL_C_Version | ( |  | ) | const

## ◆ OpenCLVersion()

String cv::ocl::Device::OpenCLVersion | ( |  | ) | const

## ◆ operator=()

Device& cv::ocl::Device::operator= | ( | const Device & | d | ) |

## ◆ preferredVectorWidthChar()

int cv::ocl::Device::preferredVectorWidthChar | ( |  | ) | const

## ◆ preferredVectorWidthDouble()

int cv::ocl::Device::preferredVectorWidthDouble | ( |  | ) | const

## ◆ preferredVectorWidthFloat()

int cv::ocl::Device::preferredVectorWidthFloat | ( |  | ) | const

## ◆ preferredVectorWidthHalf()

int cv::ocl::Device::preferredVectorWidthHalf | ( |  | ) | const

## ◆ preferredVectorWidthInt()

int cv::ocl::Device::preferredVectorWidthInt | ( |  | ) | const

## ◆ preferredVectorWidthLong()

int cv::ocl::Device::preferredVectorWidthLong | ( |  | ) | const

## ◆ preferredVectorWidthShort()

int cv::ocl::Device::preferredVectorWidthShort | ( |  | ) | const

## ◆ printfBufferSize()

size_t cv::ocl::Device::printfBufferSize | ( |  | ) | const

## ◆ profilingTimerResolution()

size_t cv::ocl::Device::profilingTimerResolution | ( |  | ) | const

## ◆ ptr()

void* cv::ocl::Device::ptr | ( |  | ) | const

## ◆ set()

void cv::ocl::Device::set | ( | void * | d | ) |

## ◆ singleFPConfig()

int cv::ocl::Device::singleFPConfig | ( |  | ) | const

## ◆ type()

int cv::ocl::Device::type | ( |  | ) | const

## ◆ vendorID()

int cv::ocl::Device::vendorID | ( |  | ) | const

## ◆ vendorName()

String cv::ocl::Device::vendorName | ( |  | ) | const

## ◆ version()

String cv::ocl::Device::version | ( |  | ) | const

## Member Data Documentation

## ◆ p

Impl* cv::ocl::Device::p
| protected

The documentation for this class was generated from the following file:

- core/include/opencv2/core/ocl.hpp